import { INodeSelector, IViewport } from '../simulator';
import { Node } from '../document';
export declare class OffsetObserver {
    readonly nodeInstance: INodeSelector;
    readonly id: string;
    private lastOffsetLeft?;
    private lastOffsetTop?;
    private lastOffsetHeight?;
    private lastOffsetWidth?;
    private _height;
    private _width;
    private _left;
    private _top;
    private _right;
    private _bottom;
    get height(): number;
    get width(): number;
    get top(): number;
    get left(): number;
    get bottom(): number;
    get right(): number;
    hasOffset: boolean;
    get offsetLeft(): number;
    get offsetTop(): number;
    get offsetHeight(): number;
    get offsetWidth(): number;
    get scale(): number;
    private pid;
    readonly viewport: IViewport;
    private isRoot;
    readonly node: Node;
    readonly compute: () => void;
    constructor(nodeInstance: INodeSelector);
    purge(): void;
    isPurged(): boolean;
}
export declare function createOffsetObserver(nodeInstance: INodeSelector): OffsetObserver | null;
