export declare class ScrollTarget {
    private target;
    get left(): number;
    get top(): number;
    scrollTo(options: {
        left?: number;
        top?: number;
    }): void;
    scrollToXY(x: number, y: number): void;
    get scrollHeight(): number;
    get scrollWidth(): number;
    private doc?;
    constructor(target: Window | Element);
}
export interface IScrollable {
    scrollTarget?: ScrollTarget | Element;
    bounds?: DOMRect | null;
    scale?: number;
}
export declare class Scroller {
    private scrollable;
    private pid;
    constructor(scrollable: IScrollable);
    get scrollTarget(): ScrollTarget | null;
    scrollTo(options: {
        left?: number;
        top?: number;
    }): void;
    scrolling(point: {
        globalX: number;
        globalY: number;
    }): void;
    cancel(): void;
}
