/// <reference types="react" />
import { IEditor } from '@alilc/lowcode-types';
import { SettingEntry } from './setting-entry';
import { SettingField } from './setting-field';
import { SettingPropEntry } from './setting-prop-entry';
import { Node } from '../../document';
import { ComponentMeta } from '../../component-meta';
import { Designer } from '../designer';
export declare class SettingTopEntry implements SettingEntry {
    readonly editor: IEditor;
    readonly nodes: Node[];
    private emitter;
    private _items;
    private _componentMeta;
    private _isSame;
    private _settingFieldMap;
    readonly path: any[];
    readonly top: this;
    readonly parent: this;
    get componentMeta(): ComponentMeta;
    get items(): (import("react").ComponentClass<any, any> | import("react").FunctionComponent<any> | import("react").ReactElement<any, string | ((props: any) => import("react").ReactElement<any, any>) | (new (props: any) => import("react").Component<any, any, any>)> | SettingField)[];
    /**
     * 同样的
     */
    get isSameComponent(): boolean;
    /**
     * 一个
     */
    get isSingle(): boolean;
    get isLocked(): boolean;
    /**
     * 多个
     */
    get isMultiple(): boolean;
    readonly id: string;
    readonly first: Node;
    readonly designer: Designer;
    disposeFunctions: any[];
    constructor(editor: IEditor, nodes: Node[]);
    private setupComponentMeta;
    private setupItems;
    private setupEvents;
    /**
     * 获取当前属性值
     */
    getValue(): any;
    /**
     * 设置当前属性值
     */
    setValue(val: any): void;
    /**
     * 获取子项
     */
    get(propName: string | number): SettingPropEntry | null;
    /**
     * 设置子级属性值
     */
    setPropValue(propName: string, value: any): void;
    /**
     * 清除已设置值
     */
    clearPropValue(propName: string): void;
    /**
     * 获取子级属性值
     */
    getPropValue(propName: string): any;
    /**
     * 获取顶层附属属性值
     */
    getExtraPropValue(propName: string): import("@alilc/lowcode-types").CompositeValue;
    /**
     * 设置顶层附属属性值
     */
    setExtraPropValue(propName: string, value: any): void;
    setProps(data: object): void;
    mergeProps(data: object): void;
    private disposeItems;
    purge(): void;
    getProp(propName: string | number): SettingPropEntry;
    getStatus(): void;
    setStatus(): void;
    getChildren(): void;
    getDOMNode(): void;
    getId(): string;
    getPage(): import("../../document").DocumentModel;
    /**
     * @deprecated
     */
    get node(): Node<import("@alilc/lowcode-types").NodeSchema>;
    getNode(): Node<import("@alilc/lowcode-types").NodeSchema>;
}
