import { ILowCodePlugin, ILowCodePluginConfig, ILowCodePluginManager, ILowCodePluginContext, ILowCodeRegisterOptions, PreferenceValueType, PluginPreference, ILowCodePluginContextApiAssembler } from './plugin-types';
export declare class LowCodePluginManager implements ILowCodePluginManager {
    private plugins;
    private pluginsMap;
    private pluginPreference?;
    contextApiAssembler: ILowCodePluginContextApiAssembler;
    constructor(contextApiAssembler: ILowCodePluginContextApiAssembler);
    private _getLowCodePluginContext;
    isEngineVersionMatched(versionExp: string): boolean;
    /**
     * register a plugin
     * @param pluginConfigCreator - a creator function which returns the plugin config
     * @param options - the plugin options
     * @param registerOptions - the plugin register options
     */
    register(pluginConfigCreator: (ctx: ILowCodePluginContext, options: any) => ILowCodePluginConfig, options?: any, registerOptions?: ILowCodeRegisterOptions): Promise<void>;
    get(pluginName: string): ILowCodePlugin | undefined;
    getAll(): ILowCodePlugin[];
    has(pluginName: string): boolean;
    delete(pluginName: string): Promise<boolean>;
    init(pluginPreference?: PluginPreference): Promise<void>;
    destroy(): Promise<void>;
    get size(): number;
    getPluginPreference(pluginName: string): Record<string, PreferenceValueType> | null | undefined;
    toProxy(): this;
    setDisabled(pluginName: string, flag?: boolean): void;
    dispose(): Promise<void>;
}
