"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.BuiltinSimulatorHostView = void 0;
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _react = _interopRequireWildcard(require("react"));
var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");
var _host = require("./host");
var _bemTools = require("./bem-tools");
require("./host.less");
var _class, _class2;
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var BuiltinSimulatorHostView = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(BuiltinSimulatorHostView, _Component);
  function BuiltinSimulatorHostView(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _this.host = void 0;
    var _this$props = _this.props,
      project = _this$props.project,
      onMount = _this$props.onMount;
    _this.host = project.simulator || new _host.BuiltinSimulatorHost(project);
    _this.host.setProps(_this.props);
    onMount === null || onMount === void 0 ? void 0 : onMount(_this.host);
    return _this;
  }
  var _proto = BuiltinSimulatorHostView.prototype;
  _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
    this.host.setProps(nextProps);
    return false;
  };
  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "lc-simulator"
    }, /*#__PURE__*/_react["default"].createElement(Canvas, {
      host: this.host
    }));
  };
  return BuiltinSimulatorHostView;
}(_react.Component);
exports.BuiltinSimulatorHostView = BuiltinSimulatorHostView;
var Canvas = (0, _lowcodeEditorCore.observer)(_class = /*#__PURE__*/function (_Component2) {
  (0, _inheritsLoose2["default"])(Canvas, _Component2);
  function Canvas() {
    return _Component2.apply(this, arguments) || this;
  }
  var _proto2 = Canvas.prototype;
  _proto2.render = function render() {
    var sim = this.props.host;
    var className = 'lc-simulator-canvas';
    var _ref = sim.deviceStyle || {},
      _ref$canvas = _ref.canvas,
      canvas = _ref$canvas === void 0 ? {} : _ref$canvas,
      _ref$viewport = _ref.viewport,
      viewport = _ref$viewport === void 0 ? {} : _ref$viewport;
    if (sim.deviceClassName) {
      className += " " + sim.deviceClassName;
    } else if (sim.device) {
      className += " lc-simulator-device-" + sim.device;
    }
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: className,
      style: canvas
    }, /*#__PURE__*/_react["default"].createElement("div", {
      ref: function ref(elmt) {
        return sim.mountViewport(elmt);
      },
      className: "lc-simulator-canvas-viewport",
      style: viewport
    }, /*#__PURE__*/_react["default"].createElement(_bemTools.BemTools, {
      host: sim
    }), /*#__PURE__*/_react["default"].createElement(Content, {
      host: sim
    })));
  };
  return Canvas;
}(_react.Component)) || _class;
var Content = (0, _lowcodeEditorCore.observer)(_class2 = /*#__PURE__*/function (_Component3) {
  (0, _inheritsLoose2["default"])(Content, _Component3);
  function Content() {
    var _this2;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this2 = _Component3.call.apply(_Component3, [this].concat(args)) || this;
    _this2.state = {
      disabledEvents: false
    };
    _this2.dispose = void 0;
    return _this2;
  }
  var _proto3 = Content.prototype;
  _proto3.componentDidMount = function componentDidMount() {
    var _this3 = this;
    var editor = _lowcodeEditorCore.globalContext.get('editor');
    var onEnableEvents = function onEnableEvents(type) {
      _this3.setState({
        disabledEvents: type
      });
    };
    editor.on('designer.builtinSimulator.disabledEvents', onEnableEvents);
    this.dispose = function () {
      editor.removeListener('designer.builtinSimulator.disabledEvents', onEnableEvents);
    };
  };
  _proto3.componentWillUnmount = function componentWillUnmount() {
    var _this$dispose;
    (_this$dispose = this.dispose) === null || _this$dispose === void 0 ? void 0 : _this$dispose.call(this);
  };
  _proto3.render = function render() {
    var sim = this.props.host;
    var disabledEvents = this.state.disabledEvents;
    var viewport = sim.viewport;
    var frameStyle = {
      transform: "scale(" + viewport.scale + ")",
      height: viewport.contentHeight,
      width: viewport.contentWidth
    };
    if (disabledEvents) {
      frameStyle.pointerEvents = 'none';
    }
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "lc-simulator-content"
    }, /*#__PURE__*/_react["default"].createElement("iframe", {
      name: "SimulatorRenderer",
      className: "lc-simulator-content-frame",
      style: frameStyle,
      ref: function ref(frame) {
        return sim.mountContentFrame(frame);
      }
    }));
  };
  return Content;
}(_react.Component)) || _class2;