import { TitleContent, SetterType, FieldExtraProps, FieldConfig, CustomView, ISetValueOptions } from '@alilc/lowcode-types';
import { Transducer } from './utils';
import { SettingPropEntry } from './setting-prop-entry';
import { SettingEntry } from './setting-entry';
export declare class SettingField extends SettingPropEntry implements SettingEntry {
    readonly isSettingField = true;
    readonly isRequired: boolean;
    readonly transducer: Transducer;
    private _config;
    extraProps: FieldExtraProps;
    private _title?;
    get title(): TitleContent;
    private _setter?;
    get setter(): SetterType | null;
    private _expanded;
    get expanded(): boolean;
    setExpanded(value: boolean): void;
    parent: SettingEntry;
    constructor(parent: SettingEntry, config: FieldConfig, settingFieldCollector?: (name: string | number, field: SettingField) => void);
    private _items;
    get items(): Array<SettingField | CustomView>;
    get config(): FieldConfig;
    private initItems;
    private disposeItems;
    createField(config: FieldConfig): SettingField;
    purge(): void;
    getConfig<K extends keyof FieldConfig>(configName?: K): FieldConfig[K] | FieldConfig;
    getItems(filter?: (item: SettingField | CustomView) => boolean): Array<SettingField | CustomView>;
    private hotValue;
    setValue(val: any, isHotValue?: boolean, force?: boolean, extraOptions?: ISetValueOptions): void;
    getHotValue(): any;
    setMiniAppDataSourceValue(data: any, options?: any): void;
    setHotValue(data: any, options?: ISetValueOptions): void;
    onEffect(action: () => void): () => void;
}
export declare function isSettingField(obj: any): obj is SettingField;
