import { NodeSchema } from '@alilc/lowcode-types';
export interface Serialization<K = NodeSchema, T = string> {
    serialize(data: K): T;
    unserialize(data: T): K;
}
export declare class History<T = NodeSchema> {
    private redoer;
    private timeGap;
    private session;
    private records;
    private point;
    private emitter;
    private asleep;
    private currentSerialization;
    setSerialization(serialization: Serialization<T, string>): void;
    constructor(dataFn: () => T | null, redoer: (data: T) => void, timeGap?: number);
    get hotData(): any;
    isSavePoint(): boolean;
    private sleep;
    private wakeup;
    go(cursor: number): void;
    back(): void;
    forward(): void;
    savePoint(): void;
    /**
     *  |    1     |     1    |    1     |
     *  | -------- | -------- | -------- |
     *  | modified | redoable | undoable |
     */
    getState(): number;
    onStateChange(func: () => any): () => void;
    onCursor(func: () => any): () => void;
    destroy(): void;
    /**
     *
     * @deprecated
     * @returns
     * @memberof History
     */
    isModified(): boolean;
}
export declare class Session {
    readonly cursor: number;
    private timeGap;
    private _data;
    private activeTimer;
    get data(): any;
    constructor(cursor: number, data: any, timeGap?: number);
    log(data: any): void;
    isActive(): boolean;
    end(): void;
    private setTimer;
    private clearTimer;
}
