import { Node, ParentalNode } from './node';
import { TransformStage } from './transform-stage';
import { NodeData } from '@alilc/lowcode-types';
import { NodeRemoveOptions } from '../../types';
export interface IOnChangeOptions {
    type: string;
    node: Node;
}
export declare class NodeChildren {
    readonly owner: ParentalNode;
    private children;
    private emitter;
    constructor(owner: ParentalNode, data: NodeData | NodeData[], options?: any);
    internalInitParent(): void;
    /**
     * 导出 schema
     */
    export(stage?: TransformStage): NodeData[];
    import(data?: NodeData | NodeData[], checkId?: boolean): void;
    /**
     * @deprecated
     * @param nodes
     */
    concat(nodes: Node[]): Node<import("@alilc/lowcode-types").NodeSchema>[];
    /**
     * 元素个数
     */
    get size(): number;
    /**
     * 是否空
     */
    isEmpty(): boolean;
    notEmpty(): boolean;
    get length(): number;
    private purged;
    /**
     * 回收销毁
     */
    purge(useMutator?: boolean): void;
    unlinkChild(node: Node): boolean;
    /**
     * 删除一个节点
     */
    delete(node: Node, purge?: boolean, useMutator?: boolean, options?: NodeRemoveOptions): boolean;
    /**
     * 插入一个节点，返回新长度
     */
    insert(node: Node, at?: number | null, useMutator?: boolean): void;
    /**
     * 取得节点索引编号
     */
    indexOf(node: Node): number;
    /**
     *
     */
    splice(start: number, deleteCount: number, node?: Node): Node[];
    /**
     * 根据索引获得节点
     */
    get(index: number): Node | null;
    /**
     * 是否存在节点
     */
    has(node: Node): boolean;
    /**
     * 迭代器
     */
    [Symbol.iterator](): {
        next(): {
            value: Node;
        };
    };
    /**
     * 遍历
     */
    forEach(fn: (item: Node, index: number) => void): void;
    /**
     * 遍历
     */
    map<T>(fn: (item: Node, index: number) => T): T[] | null;
    every(fn: (item: Node, index: number) => any): boolean;
    some(fn: (item: Node, index: number) => any): boolean;
    filter(fn: (item: Node, index: number) => any): Node<import("@alilc/lowcode-types").NodeSchema>[];
    find(fn: (item: Node, index: number) => boolean): Node<import("@alilc/lowcode-types").NodeSchema>;
    reduce(fn: (acc: any, cur: Node) => any, initialValue: any): void;
    mergeChildren(remover: (node: Node, idx: number) => boolean, adder: (children: Node[]) => NodeData[] | null, sorter: (firstNode: Node, secondNode: Node) => number): any;
    onChange(fn: (info?: IOnChangeOptions) => void): () => void;
    onInsert(fn: (node: Node) => void): () => void;
    get [Symbol.toStringTag](): string;
    private reportModified;
}
