import { EngineConfig } from '@alilc/lowcode-editor-core';
import { ILowCodePluginManager } from '@alilc/lowcode-designer';
import { IPublicApiHotkey, IPublicApiProject, IPublicApiSkeleton, IPublicApiSetters, IPublicApiMaterial, IPublicApiEvent, IPublicApiCommon } from '@alilc/lowcode-types';
import { Logger } from '@alilc/lowcode-utils';
import { ILowCodePluginContext, IPluginContextOptions, ILowCodePluginPreferenceDeclaration, IPluginPreferenceMananger, ILowCodePluginContextApiAssembler, ILowCodePluginContextPrivate } from './plugin-types';
export default class PluginContext implements ILowCodePluginContext, ILowCodePluginContextPrivate {
    hotkey: IPublicApiHotkey;
    project: IPublicApiProject;
    skeleton: IPublicApiSkeleton;
    setters: IPublicApiSetters;
    material: IPublicApiMaterial;
    event: IPublicApiEvent;
    config: EngineConfig;
    common: IPublicApiCommon;
    logger: Logger;
    plugins: ILowCodePluginManager;
    preference: IPluginPreferenceMananger;
    constructor(plugins: ILowCodePluginManager, options: IPluginContextOptions, contextApiAssembler: ILowCodePluginContextApiAssembler);
    setPreference(pluginName: string, preferenceDeclaration: ILowCodePluginPreferenceDeclaration): void;
}
