"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");
var _lowcodeUtils = require("@alilc/lowcode-utils");
var _pluginUtils = require("./plugin-utils");
/* eslint-disable no-multi-assign */
var PluginContext = /*#__PURE__*/function () {
  function PluginContext(plugins, options, contextApiAssembler) {
    this.hotkey = void 0;
    this.project = void 0;
    this.skeleton = void 0;
    this.setters = void 0;
    this.material = void 0;
    this.event = void 0;
    this.config = void 0;
    this.common = void 0;
    this.logger = void 0;
    this.plugins = void 0;
    this.preference = void 0;
    this.plugins = plugins;
    var _options$pluginName = options.pluginName,
      pluginName = _options$pluginName === void 0 ? 'anonymous' : _options$pluginName;
    this.logger = (0, _lowcodeUtils.getLogger)({
      level: 'warn',
      bizName: "designer:plugin:" + pluginName
    });
    var enhancePluginContextHook = _lowcodeEditorCore.engineConfig.get('enhancePluginContextHook');
    if (enhancePluginContextHook) {
      enhancePluginContextHook(this);
    }
    contextApiAssembler.assembleApis(this);
  }
  var _proto = PluginContext.prototype;
  _proto.setPreference = function setPreference(pluginName, preferenceDeclaration) {
    var _this = this;
    var getPreferenceValue = function getPreferenceValue(key, defaultValue) {
      if (!(0, _pluginUtils.isValidPreferenceKey)(key, preferenceDeclaration)) {
        return undefined;
      }
      var pluginPreference = _this.plugins.getPluginPreference(pluginName) || {};
      if (pluginPreference[key] === undefined || pluginPreference[key] === null) {
        return defaultValue;
      }
      return pluginPreference[key];
    };
    this.preference = {
      getPreferenceValue: getPreferenceValue
    };
  };
  return PluginContext;
}();
exports["default"] = PluginContext;