import { Logger } from '@alilc/lowcode-utils';
import { ILowCodePlugin, ILowCodePluginConfig, ILowCodePluginManager, ILowCodePluginConfigMeta } from './plugin-types';
export declare class LowCodePlugin implements ILowCodePlugin {
    config: ILowCodePluginConfig;
    logger: Logger;
    private manager;
    private emitter;
    private _inited;
    private pluginName;
    private meta;
    /**
     * 标识插件状态，是否被 disabled
     */
    private _disabled;
    constructor(pluginName: string, manager: ILowCodePluginManager, config: ILowCodePluginConfig, meta: ILowCodePluginConfigMeta);
    get name(): string;
    get dep(): string[];
    get disabled(): boolean;
    on(event: string | symbol, listener: (...args: any[]) => void): any;
    emit(event: string | symbol, ...args: any[]): boolean;
    removeAllListeners(event: string | symbol): any;
    isInited(): boolean;
    init(forceInit?: boolean): Promise<void>;
    destroy(): Promise<void>;
    setDisabled(flag?: boolean): void;
    toProxy(): this;
    dispose(): Promise<void>;
}
